
//+------------------------------------------------------------------+

#property copyright "Profitrader, "

//+------------------------------------------------------------------+

//---- properties

#property indicator_chart_window
//+------------------------------------------------------------------+

//---- input parameters


extern string _n1 = "_Increase for more history";
extern int BarCount = 5;
extern color  cAboveAvgColor = RoyalBlue;
extern color  cBelowAvgColor = Yellow;
extern color  cAverageColor = White;
extern int    iHistFontSize = 10;
extern int    iLastFontSize = 10;

extern string sFontFace = "Arial";
extern int    iCorner = 0; //0 - for top-left corner, 1 - top-right, 2 - bottom-left, 3 - bottom-right
extern int    iInfoDistanceX = 400;
extern int    iInfoDistanceY = 250;
extern int    iInfoDistanceBetween = 60;


//+------------------------------------------------------------------+

//---- globalscape


int Precision = 5;
datetime OldTime;
string ShortName;

//+------------------------------------------------------------------+

//---- buffers

double UpPos[], DnPos[], UpNeg[], DnNeg[];
double TVI[],TVIpos[],TVIneg[], TVIraw[], Trend[];
double TVItotal[];

//+------------------------------------------------------------------+

//---- extra buffers

double UpTicks[], DnTicks[];


//+------------------------------------------------------------------+

//| indicator initialization |

//+------------------------------------------------------------------+

int init()

    { 
       int iCnt;
       int iDistance;
       int iCurFontSize;
       
   ObjectCreate("Ob", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Ob"," number of candles = " + BarCount,12, "Verdana", DarkOrange);
   ObjectSet("Ob", OBJPROP_CORNER, 0);
   ObjectSet("Ob", OBJPROP_XDISTANCE, 600);
   ObjectSet("Ob", OBJPROP_YDISTANCE, 210);
       
   ArrayResize(TVI, BarCount); 
   
   SetIndexBuffer(0, TVItotal);
   SetIndexStyle(0, DRAW_NONE);
   
   
   ObjectCreate("totTVI", OBJ_LABEL, 0, 0, 0);
   ObjectSet("totTVI", OBJPROP_CORNER, 0);
   ObjectSet("totTVI", OBJPROP_XDISTANCE, 600);
   ObjectSet("totTVI", OBJPROP_YDISTANCE, 320);
   ObjectSetText("totTVI", "...", 26, sFontFace, cAverageColor);
   
   
    iDistance = iInfoDistanceX;
   for (iCnt=0;iCnt < BarCount; iCnt++) 
     {
      if (iCnt==0) iCurFontSize = iLastFontSize; 
      else iCurFontSize = iHistFontSize;
      ObjectCreate("TVI"+(BarCount-iCnt-1), OBJ_LABEL, 0, 0, 0);
      ObjectSet("TVI"+(BarCount-iCnt-1), OBJPROP_CORNER, iCorner);
      ObjectSet("TVI"+(BarCount-iCnt-1), OBJPROP_XDISTANCE, iDistance);
      ObjectSet("TVI"+(BarCount-iCnt-1), OBJPROP_YDISTANCE, iInfoDistanceY);
      ObjectSetText("TVI"+(BarCount-iCnt-1), "0.0", iCurFontSize, sFontFace, cAverageColor);
      iDistance = iDistance + iInfoDistanceBetween;
      if (iCnt == (BarCount-1))
         iDistance = iDistance + iInfoDistanceBetween;
   }
   
   
   
   
   
   
   
   

//---- data window / tooltip precision
IndicatorDigits(Precision);
//---- 7 buffers used (one still free)
IndicatorBuffers(3);
//---- 5 buffers for drawing


//---- 2 buffers for calculations

SetIndexBuffer(1, TVIraw);

//---- 6 additional buffers for calc

ArrayResize(UpTicks, BarCount); ArraySetAsSeries(UpTicks, true);
ArrayResize(DnTicks, BarCount); ArraySetAsSeries(DnTicks, true);

// ---- disable data values for histo buffers

// ---- enable data value for TVI

SetIndexLabel(4, "TVI Value");

//---- reset bar counter 

OldTime = Time[0];

//---- collect indi name



//---- end init

return(0);

}


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   int iCnt;
   ObjectDelete("totTVI");
   for (iCnt=0;iCnt < BarCount; iCnt++)
   {
      ObjectDelete("TVI"+iCnt);
   }
   return(0);
}

//+------------------------------------------------------------------+

//| indicator code |

//+------------------------------------------------------------------+

int start()

 {
   color cMsgColor;
   string sTV;
   string tTV = "...";
   int iCnt;
   int iCurFontSize;
   
  
   RefreshRates();
   
   int counted_bars = IndicatorCounted();
    if (counted_bars < 0) return (-1);
    if (counted_bars > 0) counted_bars--;

   int limit = MathMin(BarCount, Bars - counted_bars) - 1;

       double Rate1, Rate2, Rate3, Rate4, Rate5;
       double inverse = 1;
       double ask = MarketInfo(Symbol(), MODE_ASK)/100;
       double bid = MarketInfo(Symbol(), MODE_BID)/100;


// Market Delta = calculated by subtracting the volume transacted at the bid price from the volume transacted at the ask price.
/*Delta = Ask - Bid
Buy Volume (Ask Volume) = volume that traded at or above the ask price.
Sell Volume (Bid Volume) = volume that traded at or below the bid price.
Red - negative histogram bar. Delta is positive, but current price is below opening price.
Green - positive histogram bar. Delta is negative, but current price is above opening price.
Blue - positive histogram bar. Delta is positive, and current price is above opening price.
Yellow - negative histogram bar. Delta is negative, and current price is below opening price.
*/


       double delta = ask-bid;
                    //---- resize/shift extra buffers on first and every next bar
         if (Time[0] != OldTime) SyncExtraBuffers(BarCount);
                   //---- calculate ticks

           for(int i = limit; i >= 0; i--)

                {

                 UpTicks[i] = (delta + (Close[i] - Open[i]) / Point)/100;
                           //DnTicks[i] = 0;
                 DnTicks[i] = (delta + (Open[i] - Close[i]) / Point)/100;

                }

        
            //---- calculate the delta volume per bar

              for(i = limit; i >= 0; i--)
                {
                 if 
                       (UpTicks[i] > DnTicks[i])
                       TVIpos[i] = ((UpTicks[i] - DnTicks[i]) );
                 else  if
                      (UpTicks[i] < DnTicks[i])
                      TVIneg[i] = - ((DnTicks[i] - UpTicks[i]) );
                  }    
                      
                 TVIraw[i] = TVIpos[i] + TVIneg[i];


             //---- delta total
             
             
                     
                     TVItotal[0] =  TVIraw[0] + TVIraw[1] + TVIraw[2] + TVIraw[3] + TVIraw[4] 
                           + TVIraw[5] + TVIraw[6] + TVIraw[7] + TVIraw[8] + TVIraw[9]
                           + TVIraw[10] + TVIraw[11] + TVIraw[12] + TVIraw[13] + TVIraw[14] 
                           + TVIraw[15] + TVIraw[16] + TVIraw[17] + TVIraw[18] + TVIraw[19] 
                           + TVIraw[20] + TVIraw[21] + TVIraw[22] + TVIraw[23] + TVIraw[24] 
                           + TVIraw[25] + TVIraw[26] + TVIraw[27] + TVIraw[28] + TVIraw[29] 
                           + TVIraw[30] + TVIraw[31] + TVIraw[32] + TVIraw[33] + TVIraw[34]
                           + TVIraw[35] + TVIraw[36] + TVIraw[37] + TVIraw[38] + TVIraw[39] 
                           + TVIraw[40] + TVIraw[41] + TVIraw[42] + TVIraw[43] + TVIraw[44];
                  

               //---- make histogram
               for (iCnt=0;iCnt < BarCount; iCnt++)
                     {
                          if 
                           (TVI[iCnt] > 1.0)
                            cMsgColor = cAboveAvgColor;
                          else if (TVI[iCnt] < 1.0)
                                   cMsgColor = cBelowAvgColor; 
                             if (iCnt==0) iCurFontSize = iLastFontSize; 
                             else iCurFontSize = iHistFontSize;
                         sTV = DoubleToStr(NormalizeDouble(TVI[iCnt], 1), 1);
                         ObjectSetText("TVI"+iCnt, sTV, iCurFontSize, sFontFace, cMsgColor);
                      }
               
               
   if (TVItotal[0] > 1.0)
      cMsgColor = cAboveAvgColor;
   else if (TVItotal[0] < 1.0)
      cMsgColor = cBelowAvgColor; 

   tTV = DoubleToStr(NormalizeDouble(TVItotal[0], 1), 1);
   ObjectSetText("totTVI", tTV, 26, sFontFace, cMsgColor);


                                      
                                         //---- end of loop
                                    return(0);
   }
   
   
   
   
   
   
   
   

//+------------------------------------------------------------------+

//| shift extra buffers on new bar |

//+------------------------------------------------------------------+

void SyncExtraBuffers(int count)

               {
                   for (int i = count - 1; i >= 0; i--)

                        {
                          UpTicks[i + 1] = UpTicks[i];
                          DnTicks[i + 1] = DnTicks[i];
                       
                        }
                             //---- reset bar counter 
                    OldTime = Time[0];
                }

//+------------------------------------------------------------------+


//| http://www.forexfactory.com/showthread.php?t=299520 |

//+------------------------------------------------------------------+



//+------------------------------------------------------------------+

